On Fri, Sep 16, 2016 at 06:59:22PM -0700, Linus Torvalds wrote:
> On Fri, Sep 16, 2016 at 5:42 PM, Josh Poimboeuf <jpoim...@redhat.com> wrote:
> > On Fri, Sep 16, 2016 at 05:09:15PM -0700, Linus Torvalds wrote:
> >> On Fri, Sep 16, 2016 at 2:26 PM, Josh Poimboeuf <jpoim...@redhat.com> 
> >> wrote:
> >> >
> >> > Ok, how about this.  If this looks ok, would you be willing to apply it?
> >>
> >> Looks good to me. Did you test the size verification with some made-up 
> >> cases?
> >
> > Yep.  And I tested all the other edge cases that occurred to me.
> 
> Hmm. So I tested it a bit, and I found a few issues..
> 
>  (1) actual bug: you really need the "-W" flag to 'readelf'. Otherwise
> it will truncate the lines to fit in 80 columns, which in turn limits
> symbol names to 25 characters or something like that.
> 
>  (2) usability: I have been known to want to look up multiple symbols.
> So could we support a syntax like
> 
>        /scripts/faddr2line vmlinux function1+15/226 other_fn_name+32/128
> 
>      or something like that?
> 
>  (3) noise: I have to say that it seems to work really well, but the
> "skipping" messages are a bit verbose.
> 
>      I guess they practically never actually *trigger*, but
> 
>      [torvalds@i7 linux]$ ./scripts/faddr2line vmlinux type_show+0x10/45
>      skipping type_show address at 0xffffffff81023690 due to size
> mismatch (45 != 166)
>      skipping type_show address at 0xffffffff811894f0 due to size
> mismatch (45 != 41)
>      /home/torvalds/v2.6/linux/drivers/video/backlight/backlight.c:213
>      skipping type_show address at 0xffffffff814e9340 due to size
> mismatch (45 != 119)
>      skipping type_show address at 0xffffffff8157a080 due to size
> mismatch (45 != 50)
>      skipping type_show address at 0xffffffff815bbeb0 due to size
> mismatch (45 != 38)
>      skipping type_show address at 0xffffffff815ea8c0 due to size
> mismatch (45 != 35)
>      skipping type_show address at 0xffffffff8162c650 due to size
> mismatch (45 != 40)
>      skipping type_show address at 0xffffffff8162f910 due to size
> mismatch (45 != 38)
>      skipping type_show address at 0xffffffff81694ec0 due to size
> mismatch (45 != 26)
> 
>      it's almost hard to pick out the case that succeeded from all the
> noise from the ones that didn't.
> 
>  (4) ambiguous "inlining" vs "multiple possible cases":
> 
>      [torvalds@i7 linux]$ ./scripts/faddr2line vmlinux free+15/36
>      /home/torvalds/v2.6/linux/./include/crypto/algapi.h:302
>      /home/torvalds/v2.6/linux/crypto/lrw.c:377
>      /home/torvalds/v2.6/linux/./include/crypto/algapi.h:302
>      /home/torvalds/v2.6/linux/crypto/xts.c:334
> 
>      That's actually two different cases, both of which inline
> crypto_instance_ctx(), and both of which are really the exact same
> code (just lrw vs xts), so they have the same name and size.
> 
>  (5) I'd love for the pathnames to be shown relative to the root of the 
> project

I addressed all of the above issues, and also added the -f and -p flags
to addr2line which Rabin suggested.

One caveat with #5 (relative path names).  Looking at DW_AT_comp_dir
wouldn't work, because that's the *object* directory, not the source
directory.

The only working (and fast) approach I could come up with was an ugly
hack.  It assumes that start_kernel() is in init/main.c.  Before doing
the _real_ addr2line, it first runs addr2line for start_kernel() and
strips the relative path:

        local start_kernel_addr=$(readelf -sW $objfile | awk '$8 == 
"start_kernel" {printf "0x%s", $2}')
        [[ -z $start_kernel_addr ]] && return

        local file_line=$(addr2line -e $objfile $start_kernel_addr)
        [[ -z $file_line ]] && return

        local prefix=${file_line%init/main.c:*}
        [[ $prefix = $file_line ]] && return

        DIR_PREFIX=$prefix

And of course that only works when the object file is vmlinux.  If it
can't find start_kernel() in init/main.c, it gracefully falls back to
just printing the absolute path.

---

From: Josh Poimboeuf <jpoim...@redhat.com>
Subject: [PATCH v3] scripts: add script for translating stack dump function
 offsets

addr2line doesn't work with KASLR addresses.  Add a basic addr2line
wrapper script which takes the 'func+offset/size' format as input.

Signed-off-by: Josh Poimboeuf <jpoim...@redhat.com>
---
 scripts/faddr2line | 177 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 177 insertions(+)
 create mode 100755 scripts/faddr2line

diff --git a/scripts/faddr2line b/scripts/faddr2line
new file mode 100755
index 0000000..4fbfe83
--- /dev/null
+++ b/scripts/faddr2line
@@ -0,0 +1,177 @@
+#!/bin/bash
+#
+# Translate stack dump function offsets.
+#
+# addr2line doesn't work with KASLR addresses.  This works similarly to
+# addr2line, but instead takes the 'func+0x123' format as input:
+#
+#   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
+#   meminfo_proc_show+0x5/0x568:
+#   meminfo_proc_show at fs/proc/meminfo.c:27
+#
+# If the address is part of an inlined function, the full inline call chain is
+# printed:
+#
+#   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
+#   native_write_msr+0x6/0x27:
+#   arch_static_branch at arch/x86/include/asm/msr.h:121
+#    (inlined by) static_key_false at include/linux/jump_label.h:125
+#    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
+#
+# The function size after the '/' in the input is optional, but recommended.
+# It's used to help disambiguate any duplicate symbol names, which can occur
+# rarely.  If the size is omitted for a duplicate symbol then it's possible for
+# multiple code sites to be printed:
+#
+#   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
+#   raw_ioctl+0x5/0x20:
+#   raw_ioctl at drivers/char/raw.c:122
+#
+#   raw_ioctl+0x5/0xb1:
+#   raw_ioctl at net/ipv4/raw.c:876
+#
+# Multiple addresses can be specified on a single command line:
+#
+#   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 
free_reserved_area+0x90
+#   type_show+0x10/0x2d:
+#   type_show at drivers/video/backlight/backlight.c:213
+#
+#   free_reserved_area+0x90/0x123:
+#   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
+
+
+set -o errexit
+set -o nounset
+
+command -v awk >/dev/null 2>&1 || die "awk isn't installed"
+command -v readelf >/dev/null 2>&1 || die "readelf isn't installed"
+command -v addr2line >/dev/null 2>&1 || die "addr2line isn't installed"
+
+usage() {
+       echo "usage: faddr2line <object file> <func+offset> <func+offset>..." 
>&2
+       exit 1
+}
+
+warn() {
+       echo "$1" >&2
+}
+
+die() {
+       echo "ERROR: $1" >&2
+       exit 1
+}
+
+# Try to figure out the source directory prefix so we can remove it from the
+# addr2line output.  HACK ALERT: This assumes that start_kernel() is in
+# kernel/init.c!  This only works for vmlinux.  Otherwise it falls back to
+# printing the absolute path.
+find_dir_prefix() {
+       local objfile=$1
+
+       local start_kernel_addr=$(readelf -sW $objfile | awk '$8 == 
"start_kernel" {printf "0x%s", $2}')
+       [[ -z $start_kernel_addr ]] && return
+
+       local file_line=$(addr2line -e $objfile $start_kernel_addr)
+       [[ -z $file_line ]] && return
+
+       local prefix=${file_line%init/main.c:*}
+       if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
+               return
+       fi
+
+       DIR_PREFIX=$prefix
+       return 0
+}
+
+__faddr2line() {
+       local objfile=$1
+       local func_addr=$2
+       local dir_prefix=$3
+       local print_warnings=$4
+
+       local func=${func_addr%+*}
+       local offset=${func_addr#*+}
+       offset=${offset%/*}
+       local size=
+       [[ $func_addr =~ "/" ]] && size=${func_addr#*/}
+
+       if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
+               warn "bad func+offset $func_addr"
+               DONE=1
+               return
+       fi
+
+       # Go through each of the object's symbols which match the func name.
+       # In rare cases there might be duplicates.
+       while read symbol; do
+               local fields=($symbol)
+               local sym_base=0x${fields[1]}
+               local sym_size=${fields[2]}
+               local sym_type=${fields[3]}
+
+               # calculate the address
+               local addr=$(($sym_base + $offset))
+               if [[ -z $addr ]] || [[ $addr = 0 ]]; then
+                       warn "bad address: $sym_base + $offset"
+                       DONE=1
+                       return
+               fi
+               local hexaddr=0x$(printf %x $addr)
+
+               # weed out non-function symbols
+               if [[ $sym_type != "FUNC" ]]; then
+                       [[ $print_warnings = 1 ]] &&
+                               echo "skipping $func address at $hexaddr due to 
non-function symbol"
+                       continue
+               fi
+
+               # if the user provided a size, make sure it matches the 
symbol's size
+               if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
+                       [[ $print_warnings = 1 ]] &&
+                               echo "skipping $func address at $hexaddr due to 
size mismatch ($size != $sym_size)"
+                       continue;
+               fi
+
+               # make sure the provided offset is within the symbol's range
+               if [[ $offset -gt $sym_size ]]; then
+                       [[ $print_warnings = 1 ]] &&
+                               echo "skipping $func address at $hexaddr due to 
size mismatch ($offset > $sym_size)"
+                       continue
+               fi
+
+               # separate multiple entries with a blank line
+               [[ $FIRST = 0 ]] && echo
+               FIRST=0
+
+               local hexsize=0x$(printf %x $sym_size)
+               echo "$func+$offset/$hexsize:"
+               addr2line -fpie $objfile $hexaddr | sed "s;$dir_prefix;;"
+               DONE=1
+
+       done < <(readelf -sW $objfile | awk -v f=$func '$8 == f {print}')
+}
+
+[[ $# -lt 2 ]] && usage
+
+objfile=$1
+[[ ! -f $objfile ]] && die "can't find objfile $objfile"
+shift
+
+DIR_PREFIX=supercalifragilisticexpialidocious
+find_dir_prefix $objfile
+
+FIRST=1
+while [[ $# -gt 0 ]]; do
+       func_addr=$1
+       shift
+
+       # print any matches found
+       DONE=0
+       __faddr2line $objfile $func_addr $DIR_PREFIX 0
+
+       # if no match was found, print warnings
+       if [[ $DONE = 0 ]]; then
+               __faddr2line $objfile $func_addr $DIR_PREFIX 1
+               warn "no match for $func_addr"
+       fi
+done
-- 
2.7.4

Reply via email to